package org.example.proyectofinalmacedonia;

import java.io.FileNotFoundException;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.YuvImage;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;


public class Dibujar extends Activity implements OnTouchListener,  SensorEventListener {

	boolean hayValorInicial = false;
	
	ImageView eligeImageView;
	Button eligeFoto;
	ImageButton rojo;
	ImageButton azul;
	ImageButton sprait;
	ImageButton lapiz;
	ImageButton rectangulo;
	
	Bitmap bmp;
	Bitmap alteredBitmap;
	Canvas canvas;
	Paint paint;
	Matrix matrix;

	int color = Color.RED;
	int tipoPincel = 1;
	static int LAPIZ = 1;
	static int SPRAIT = 2;
	static int RECTANGULO = 3;
	
	SensorManager mSensorManager;
	Sensor mAccelerometer;
	float mLastX;
	float mLastY;
	float mLastZ;
	private final float NOISE = (float) 4.0;
	
	float downx = 0;
	float downy = 0;
	float upx = 0;
	float upy = 0;
	int anchoPincel = 10;
	
	public int IDENTIFICADOR_ACTIVIDAD_DIBUJAR = 1234;
	
	private boolean fotoCargada = false;
	
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.dibujar);
		
		hayValorInicial = false;
		
		mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
		mAccelerometer = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		mSensorManager.registerListener(this, mAccelerometer, SensorManager.SENSOR_DELAY_NORMAL);
		
		eligeImageView = (ImageView) this.findViewById(R.id.elige_imagen_view);
		eligeFoto = (Button) this.findViewById(R.id.elige_foto_button);

		eligeFoto.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Intent eligeFotoIntent = new Intent(Intent.ACTION_PICK,	android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
				startActivityForResult(eligeFotoIntent, IDENTIFICADOR_ACTIVIDAD_DIBUJAR);			
			}
		});
		
		rojo = (ImageButton) this.findViewById(R.id.rojo);
		azul = (ImageButton) this.findViewById(R.id.azul);
		sprait = (ImageButton) this.findViewById(R.id.sprait);
		lapiz = (ImageButton) this.findViewById(R.id.lapiz);
		rectangulo = (ImageButton) this.findViewById(R.id.rectangulo);
		
		rojo.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				color = Color.RED;
			}
		});
		
		
		azul.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				color = Color.BLUE;
			}
		});		
		
		
		sprait.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				tipoPincel = Dibujar.SPRAIT;
			}
		});			
		
		
		lapiz.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				tipoPincel = Dibujar.LAPIZ;
			}
		});				
		
		
		rectangulo.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				tipoPincel = Dibujar.RECTANGULO;
			}
		});	
		
		
		eligeImageView.setOnTouchListener(this);
	}

	
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);

		if (resultCode == RESULT_OK && requestCode == IDENTIFICADOR_ACTIVIDAD_DIBUJAR && data != null) {
			Uri imageFileUri = data.getData();

			LinearLayout imagenLayoutImagen = (LinearLayout) this.findViewById(R.id.imagenLayoutImagen);
			
			float maxAlto  = imagenLayoutImagen.getHeight();
			float maxAncho = imagenLayoutImagen.getWidth();

			try {
				BitmapFactory.Options options = new BitmapFactory.Options();
				
				//Ponemos esto a true para que en la llamada a decodeStream no nos cargue la imagen si no que nos devuelva el tamao slo
				options.inJustDecodeBounds = true;
				bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, options);
				

				int heightRatio = (int) Math.ceil(options.outHeight / maxAlto);
				int widthRatio  = (int) Math.ceil(options.outWidth	/ maxAncho);
				
				int maximo = (int) Math.max(Math.ceil(heightRatio), Math.ceil(widthRatio));
				int maximoPotencia2 = 1;
				
				//Esto lo hago para forzar que el valor que le pasemos a inSampleSize sea una potencia de 2 (1,2,4,8,16...)
				while (maximoPotencia2 < maximo) {
					maximoPotencia2 *= 2;
				}
					
				options.inSampleSize = maximoPotencia2;
				
				options.inJustDecodeBounds = false;
				bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, options);
				
				alteredBitmap = Bitmap.createBitmap(bmp.getWidth(), bmp.getHeight(), bmp.getConfig());
				
				canvas = new Canvas(alteredBitmap);
				paint = new Paint();
				paint.setColor(color);
				paint.setStrokeWidth(5);
				matrix = new Matrix();
				canvas.drawBitmap(bmp, matrix, paint);
				eligeImageView.setImageBitmap(alteredBitmap);
				eligeImageView.setOnTouchListener(this);
				fotoCargada = true;
				
			} catch (FileNotFoundException e) {
				Log.v("ERROR", e.toString());
			}
		}
	}
				
	
	
	private void pintarSprait(){
		float rdx, rdy, rux, ruy = 0;
		
		for (int i = 0; i < anchoPincel; i++){
			rdx = downx + (int)Math.ceil(Math.random()*30) -15;
			rdy = downy + (int)Math.ceil(Math.random()*30) -15;
			rux = upx + (int)Math.ceil(Math.random()*30) -15;
			ruy = upy + (int)Math.ceil(Math.random()*30) -15;
			
			if (rdx<0) rdx=0;
			if (rdy<0) rdy=0;
			if (rux<0) rux=0;
			if (ruy<0) ruy=0;
			
			canvas.drawLine(rdx, rdy, rux, ruy, paint);
		}
	}



	@Override
	public boolean onTouch(View v, MotionEvent event) {
		paint.setColor(color);
		int action = event.getAction();
		
		switch (action) {
			case MotionEvent.ACTION_DOWN:
				downx = event.getX();
				downy = event.getY();
				break;
				
			case MotionEvent.ACTION_MOVE:
				upx = event.getX();
				upy = event.getY();
				
				switch (tipoPincel) {
					case 1:
						canvas.drawLine(downx, downy, upx, upy, paint);
						break;
					case 2:
						pintarSprait();
						break;
					default:
						break;
				}

				eligeImageView.invalidate();
				if (tipoPincel != Dibujar.RECTANGULO){
					downx = upx;
					downy = upy;
				}
				break;
				
			case MotionEvent.ACTION_UP:
				upx = event.getX();
				upy = event.getY();
				
				switch (tipoPincel) {
					case 1:
						canvas.drawLine(downx, downy, upx, upy, paint);
						break;
					case 2:
						pintarSprait();
						break;
					case 3:
						canvas.drawRect(downx, downy, upx, upy, paint);
						break;
					default:
						break;
				}
				
				eligeImageView.invalidate();
				break;
				
			case MotionEvent.ACTION_CANCEL:
				break;
				
			default:
				break;
		}

		return true;
	}		
				
			
	
	protected void onResume() {
		super.onResume();

		mSensorManager.registerListener(this, mAccelerometer, SensorManager.SENSOR_DELAY_NORMAL);
	}

	
	
	protected void onPause() {
		super.onPause();

		mSensorManager.unregisterListener(this);
	}
	
	
	
	@Override
	public void onAccuracyChanged(Sensor sensor, int accuracy) {
	}

	
	
	@Override
	public void onSensorChanged(SensorEvent event) {
		
		if (fotoCargada) {
			float x = event.values[0];
			float y = event.values[1];
			float z = event.values[2];
	
			if (!hayValorInicial) {
				mLastX = x;
				mLastY = y;
				mLastZ = z;
				hayValorInicial = true;
				
			} else {
				float deltaX = Math.abs(mLastX - x);
				float deltaY = Math.abs(mLastY - y);
				float deltaZ = Math.abs(mLastZ - z);
	
				if (deltaX < NOISE) {
					deltaX = (float) 0.0;
				}
	
				if (deltaY < NOISE) {
					deltaY = (float) 0.0;
				}
	
				if (deltaZ < NOISE) {
					deltaZ = (float) 0.0;
				}
	
				mLastX = x;
				mLastY = y;
				mLastZ = z;
				
				if (deltaX > deltaY  ||  deltaY > deltaX) {
					alteredBitmap = Bitmap.createBitmap(bmp.getWidth(), bmp.getHeight(), bmp.getConfig());
					canvas = new Canvas(alteredBitmap);
					paint = new Paint();
					paint.setColor(color);
					paint.setStrokeWidth(5);
					matrix = new Matrix();
					canvas.drawBitmap(bmp, matrix, paint);
					eligeImageView.setImageBitmap(alteredBitmap);
				} 
			}
		}
	}


}
