package org.example.proyectofinalmacedonia;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.List;

import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.ListFragment;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;


public class EncriptarListado extends ListFragment {

	String listaMensajes[];
	List<Mensaje> msgs;
	

	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	}
	
	

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		
		MensajeDataSource msgDS = new MensajeDataSource(getActivity().getApplicationContext());
		msgDS.open();
		msgs = msgDS.getAll();
		msgDS.close();
		
		listaMensajes = new String[msgs.size()];
		for (int i = 0; i < msgs.size(); i++) {
			listaMensajes[i] = msgs.get(i).toString();
		}

		ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity(), android.R.layout.simple_list_item_1, listaMensajes);

		setListAdapter(adapter);
	}
	
	

	@Override
	public void onListItemClick(ListView list, View view, int position, long id) {
		super.onListItemClick(list, view, position, id);
		StringBuffer outStringBuf = new StringBuffer();
		
		
		try {
			String stadoSD = Environment.getExternalStorageState();

			if (!stadoSD.equals(Environment.MEDIA_MOUNTED)) {
				Toast.makeText(getActivity().getBaseContext(), "No puedo leer en la memoria externa", Toast.LENGTH_LONG).show();
			}
			
			FileInputStream f = new FileInputStream(MensajeDataSource.ruta.getPath() + MensajeDataSource.NOMBRE_FICHERO + msgs.get(position).getId());
			BufferedReader entrada = new BufferedReader(new InputStreamReader(f));
			
			String linea;

			do {
				linea = entrada.readLine();
				if (linea != null) {
		            outStringBuf.append(linea);
		            outStringBuf.append("\n");
				}
			} while (linea != null);

			f.close();
		} catch (Exception e) {
			Log.e("Asteroides", e.getMessage(), e);
		}
		
		
		EncriptarClase encriptar = new EncriptarClase(EncriptarClase.clave);
		String desEncriptado = encriptar.decrypt(outStringBuf.toString());
		String desEncriptadoBD = encriptar.decrypt(msgs.get(position).getCodificado());
		
		Intent intent = new Intent(this.getActivity(), Desencriptar.class);
		intent.putExtra("TEXTO_DESENCRIPTADO", desEncriptado);
		intent.putExtra("TEXTO_DESENCRIPTADO_BD", desEncriptadoBD);
		startActivity(intent);
	}
	

}
