package org.example.proyectofinalmacedonia;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.List;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Environment;
import android.util.Log;
import android.widget.Toast;


public class MensajeDataSource {

	private SQLiteDatabase database;
	private MySQLiteHelper dbHelper;
	private String[] allColumns = { MySQLiteHelper.COLUMN_MSG_ID, MySQLiteHelper.COLUMN_MSG_CODIFICADO };
	
	public static File ruta = new File(Environment.getExternalStorageDirectory() + "/Android/data/org.example.proyectofinalmacedonia/files/");
	public static String NOMBRE_FICHERO = "/fichero_proyecto_final_";
	
	
	
	public MensajeDataSource(Context context) {
		dbHelper = new MySQLiteHelper(context);
	}
	
	

	public void open() throws SQLException {
		database = dbHelper.getWritableDatabase();
	}
	
	

	public void close() {
		dbHelper.close();
	}
	
	

	public Mensaje createMensaje(String mensaje, Context context) {
		ContentValues values = new ContentValues();
		values.put(MySQLiteHelper.COLUMN_MSG_CODIFICADO, mensaje);

		long insertId = database.insert(MySQLiteHelper.TABLE_MSG, null, values);
		Cursor cursor = database.query(MySQLiteHelper.TABLE_MSG, allColumns, MySQLiteHelper.COLUMN_MSG_ID + " = " + insertId, null, null, null, null);
		cursor.moveToFirst();
		
		Mensaje newMensaje = cursorToMensaje(cursor);
		cursor.close();
		
		if (!ruta.exists()) {
			ruta.mkdirs();
		}
		
		try {
			String stadoSD = Environment.getExternalStorageState();

			if (!stadoSD.equals(Environment.MEDIA_MOUNTED) || stadoSD.equals(Environment.MEDIA_MOUNTED_READ_ONLY)) {
				Toast.makeText(context, "No puedo escribir en la memoria externa", Toast.LENGTH_LONG).show();
			}
			
			FileOutputStream f = new FileOutputStream(ruta.getPath() + MensajeDataSource.NOMBRE_FICHERO + insertId, true);
			
			f.write(mensaje.getBytes());
			f.close();
			
		} catch (Exception e) {
			Log.e("Asteroides", e.getMessage(), e);
		}

		return newMensaje;
	}

	
	
	public void delete(Mensaje mensaje) {
		long id = mensaje.getId();
		System.out.println("Comment deleted with id: " + id);
		database.delete(MySQLiteHelper.TABLE_MSG, MySQLiteHelper.COLUMN_MSG_ID + " = " + id, null);
	}
	
	

	public List<Mensaje> getAll() {
		List<Mensaje> msgs = new ArrayList<Mensaje>();

		Cursor cursor = database.query(MySQLiteHelper.TABLE_MSG, allColumns, null, null, null, null, MySQLiteHelper.COLUMN_MSG_ID + " desc");
		cursor.moveToFirst();
		
		while (!cursor.isAfterLast()) {
			Mensaje mensaje = cursorToMensaje(cursor);
			msgs.add(mensaje);
			cursor.moveToNext();
		}
		
		cursor.close();
		return msgs;
	}
	
	

	public Mensaje getMensaje(long id) {
		String[] arg = { id + "" };
		Cursor cursor = database.query(MySQLiteHelper.TABLE_MSG, allColumns, MySQLiteHelper.COLUMN_MSG_ID + " = ?", arg, null, null, MySQLiteHelper.COLUMN_MSG_ID + " desc");
		
		Mensaje mensaje = null;
		cursor.moveToFirst();
		
		if (cursor.isAfterLast()) {
			mensaje = cursorToMensaje(cursor);
		}
		
		cursor.close();
		return mensaje;
	}
	
	

	private Mensaje cursorToMensaje(Cursor cursor) {
		Mensaje mensaje = new Mensaje();
		mensaje.setId(cursor.getLong(0));
		mensaje.setCodificado(cursor.getString(1));

		return mensaje;
	}
	
}
