package org.example.proyectofinalmacedonia;


import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentTabHost;
import android.view.inputmethod.InputMethodManager;
import android.widget.TabHost.OnTabChangeListener;

 
public class MetodoEncriptacion extends FragmentActivity  {

   private FragmentTabHost tabHost;

   @Override
   protected void onCreate(Bundle savedInstanceState) {

     super.onCreate(savedInstanceState);
     setContentView(R.layout.metodo_encriptacion);
     
     tabHost = (FragmentTabHost) findViewById(android.R.id.tabhost);
     tabHost.setup(this, getSupportFragmentManager(), android.R.id.tabcontent);
     
     String t_tab1 = getResources().getString(R.string.t_tab1); 
     String t_tab2 = getResources().getString(R.string.t_tab2);
     
     Drawable candadoCerrado = getResources().getDrawable(R.drawable.candado_cerrado);
     Drawable candadoAbierto = getResources().getDrawable(R.drawable.candado_abierto);

     
     tabHost.addTab(tabHost.newTabSpec("tab1").setIndicator(t_tab1, candadoCerrado), Encriptar.class, null);
     tabHost.addTab(tabHost.newTabSpec("tab2").setIndicator(t_tab2, candadoAbierto), EncriptarListado.class, null);
     
     
     tabHost.getTabWidget().getChildAt(0).setBackgroundColor(Color.parseColor("#3333FF"));
     tabHost.getTabWidget().getChildAt(1).setBackgroundColor(Color.parseColor("#7777FF"));
     
     tabHost.getTabWidget().setCurrentTab(0);
     
     tabHost.setOnTabChangedListener(
    		 new OnTabChangeListener() { 
    			 
    			 @Override
    			 public void onTabChanged(String tabId) { 
    				 InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE); 
    				 
    				 if (tabId.equals("tab1")) {
    					 imm.toggleSoftInputFromWindow (
    							 tabHost.getApplicationWindowToken(), 
    							 InputMethodManager.SHOW_FORCED, 
    							 InputMethodManager.HIDE_IMPLICIT_ONLY );
    				 } else {
    					 imm.hideSoftInputFromWindow(tabHost.getApplicationWindowToken(), 0); 
    				 }
    				 
    			     for(int i=0; i<tabHost.getTabWidget().getChildCount(); i++) {
    			         tabHost.getTabWidget().getChildAt(i).setBackgroundColor(Color.parseColor("#7777FF"));
    			     }

    			     tabHost.getTabWidget().getChildAt(tabHost.getCurrentTab()).setBackgroundColor(Color.parseColor("#3333FF"));
    			 }
    		 });
     
   }
   
   
}