package org.example.proyectofinalmacedonia;

import java.io.File;
import java.io.FileInputStream;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.os.Environment;
import android.util.Log;


public class MySQLiteHelper extends SQLiteOpenHelper {

	public static final String TABLE_MSG = "msg";
	public static final String COLUMN_MSG_ID = "msg_id";
	public static final String COLUMN_MSG_CODIFICADO = "msg_codificado";

	private static final String DATABASE_NAME = "proyectoFinal.db";
	private static final int DATABASE_VERSION = 1;
	private Context context;
	
	

	private static final String DATABASE_CREATE_MSG = "create table "
			+ TABLE_MSG + "(" + COLUMN_MSG_ID
			+ " integer primary key autoincrement, " + COLUMN_MSG_CODIFICADO
			+ " text not null);";
											  
  
  
	public MySQLiteHelper(Context context) {
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
		this.context = context;
	}

	
	
	@Override
	public void onCreate(SQLiteDatabase database) {
		database.execSQL(DATABASE_CREATE_MSG);
	}
  
	

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		db.execSQL("DROP TABLE IF EXISTS " + TABLE_MSG);

		if (MensajeDataSource.ruta.exists()) {
			File[] ficheros = MensajeDataSource.ruta.listFiles();
			if (ficheros != null) {
				for (int i = 0; i < ficheros.length; i++) {
					ficheros[i].delete();
				}
			}
		}

		onCreate(db);
	}

} 
