package org.example.proyectofinalmacedonia;


import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.IBinder;
import android.support.v4.app.NotificationCompat;


public class ServicioLlamada extends Service {

	public static final int ID_NOTIFICACION_CREAR = 1;  

	
	@Override
	public void onCreate() {
	}

	
	
	@Override
	public int onStartCommand(Intent intent, int flags, int idArranque) {
		Bundle extras = intent.getExtras();
		
		NotificationCompat.Builder notific = new NotificationCompat.Builder(this)
												.setContentTitle("Creando Servicio LLAMADA")
												.setSmallIcon(R.drawable.ic_launcher)
												.setContentText("Para encriptar la llamada recibida pulse aqu")
												.setLargeIcon(BitmapFactory.decodeResource(getResources(),android.R.drawable.ic_media_play))
												.setWhen(System.currentTimeMillis() + 1000 * 60 * 60)
												.setContentInfo("ms info")
												.setTicker("LLAMADA Recibida! " + extras.getString("LLAMADA_INFO"));
		
		
		

		Intent intencion = new Intent(ServicioLlamada.this, ProyectoFinalMacedonia.class);
		
		if (extras != null) {
			intencion.putExtra("INFORMACION_LLAMADA",  extras.getString("LLAMADA_INFO"));
		}

		PendingIntent intencionPendiente = PendingIntent.getActivity(this, 0, intencion, 0);
		notific.setContentIntent(intencionPendiente);

		NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
		notificationManager.notify(ID_NOTIFICACION_CREAR, notific.build());

		return START_STICKY;
	}

	
	
	@Override
	public void onDestroy() {
		NotificationManager notificationManager = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
		notificationManager.cancel(ID_NOTIFICACION_CREAR);
	}

	
	
	@Override
	public IBinder onBind(Intent intencion) {
		return null;
	}

}
