package org.example.proyectofinalmacedonia;


public enum TipoConversionDivisas { 
	
    EUR_DOL("Euro - Dlar", 	"EUR", 	"USD"),
    EUR_LIB("Euro - Libr", 		"EUR", 	"GBP"),
    DOL_EUR("Dlar - Euro", 	"USD", 	"EUR"),
    DOL_LIB("Dlar - Libra", 	"USD", 	"GBP"),
    LIB_EUR("Libra - Euro", 	"GBP", 	"EUR"),
    LIB_DOL("Libra - Dlar", 	"GBP", 	"USD");

	private final String texto; 
	private final String divisaOrigen;  
	private final String divisaDestino;  
	
	
	TipoConversionDivisas(String texto, String divisaOrigen, String divisaDestino) {
		this.texto = texto;
		this.divisaOrigen = divisaOrigen;
		this.divisaDestino = divisaDestino;
	}
	
	
	
	public String getTexto() { 
		return texto; 
		
	}
	
	
	
	public String getDivisaOrigen() { 
		return divisaOrigen; 
	}   
	
	
	
	public String getDivisaDestino() { 
		return divisaDestino; 
	}   
	

	
	public static String[] getNombres() {
		String[] resultado = new String[TipoConversionDivisas.values().length];

		for (TipoConversionDivisas tipo : TipoConversionDivisas.values()) {
			resultado[tipo.ordinal()] = tipo.texto;
		}
		return resultado;
	}
	
}